// Code generated by ragel. DO NOT EDIT.
// source: parser.rl
package parser

import (
    "time"
)

const (
    emptyString = ""
)

var (
    emptyTime = time.Time{}
)

type ParserRecord struct {
	Date time.Time
	URL  string
	Code int
}

%%{
  machine DataParser;
  write data;
}%%

func DataMatcher(data []byte) ([]ParserRecord, []ParserRecord) {
    cs, p, pe, eof := 0, 0, len(data), len(data)
    _ = eof

    start_pointer := p;
    var key_value string
    key_processed := false

    var value_value string

    var currentRecord ParserRecord
    currentRecordProcessed := false
    currentRecordErrors := false

    errSlice := make([]ParserRecord, 0)
    succSlice := make([]ParserRecord, 0)

    %%{
        key_string = ([^\t\n=])*;
        value_string = ([^\t\n])*;

        action StartPos {
            start_pointer = p;
        }

        action EndKeyPos {
            key_value = string(data[start_pointer:p])
            key_processed = true
        }

        action EndValuePos {
            value_value = string(data[start_pointer:p])

            if key_processed {
                processKeyValue(&currentRecord, &currentRecordProcessed, &currentRecordErrors, key_value, value_value)
            } else {
                fnext start;
            }
        }

        action EndOfRecord {
            if currentRecordProcessed && !currentRecordErrors {
                processEndOfRecord(&currentRecord, &errSlice, &succSlice)
            }

            currentRecordProcessed = false
            currentRecordErrors = false
            currentRecord.URL = emptyString
            currentRecord.Date = emptyTime
            currentRecord.Code = -1

            fnext start;
        }

        action Reset {
            currentRecordProcessed = false
            currentRecordErrors = false
            currentRecord.URL = emptyString
            currentRecord.Date = emptyTime
            currentRecord.Code = -1

            fnext start;
        }

        records = (
            start: (
                (key_string > StartPos %EndKeyPos) ('=' ((value_string > StartPos %EndValuePos) ('\t'|'\t'?'\n' @ EndOfRecord)) | [\t\n] @Reset)
            )
        );

        main := (records)*;

        write init;
        write exec;
    }%%

    return errSlice, succSlice
}
