#!/usr/bin/env python
# -*- coding: utf-8 -*-

from balancer.test.util.config import gen_config_class

gen_config_class('IcookieConfig', 'icookie.lua', args=['backend_port'], kwargs={
    'file_switch': None,
    'trust_parent': None,
    'trust_children': None,
    'use_default_keys': True,
    'keys_file': None,
    'enable_set_cookie': None,
    'enable_decrypting': None,
    'decrypted_uid_header': None,
    'error_header': None,
    'info_header': None,
    'encrypted_header': None,
    'src_icookie_header': None,
    'take_randomuid_from': 'X-Yandex-RandomUID',
    'domains': '.yandex.ru,.yandex.com.tr,.yandex.uz',
    'flag_secure': None,
    'scheme_bitmask': 3,  # force enable nossl too
    'force_equal_to_yandexuid': None,
    'force_generate_from_searchapp_uuid': None,
    'force_generate_from_yandex_browser_uuid': None,
    'force_generate_from_transport': None,
    'max_transport_age': None,
    'exp_type': None,
    'exp_A_testid': None,
    'exp_B_testid': None,
    'exp_salt': None,
    'exp_A_slots': None,
    'exp_B_slots': None,
    'enable_parse_searchapp_uuid': None,
    'enable_guess_searchapp': None,
})

gen_config_class('IcookieSSLConfig', 'icookie_ssl.lua', args=['backend_port', 'cert_dir'], kwargs={
    'file_switch': None,
    'trust_parent': None,
    'trust_children': None,
    'use_default_keys': True,
    'keys_file': None,
    'enable_set_cookie': None,
    'enable_decrypting': None,
    'decrypted_uid_header': None,
    'error_header': None,
    'info_header': None,
    'encrypted_header': None,
    'src_icookie_header': None,
    'take_randomuid_from': 'X-Yandex-RandomUID',
    'domains': '.yandex.ru,.yandex.com.tr,.yandex.uz',
    'flag_secure': None,
    'scheme_bitmask': None,
    'force_equal_to_yandexuid': None,
    'force_generate_from_searchapp_uuid': None,
    'force_generate_from_yandex_browser_uuid': None,
    'force_generate_from_transport': None,
    'max_transport_age': None,
    'exp_type': None,
    'exp_A_testid': None,
    'exp_B_testid': None,
    'exp_salt': None,
    'exp_A_slots': None,
    'exp_B_slots': None,
    'enable_parse_searchapp_uuid': None,
    'enable_guess_searchapp': None,
})

