OWNER(g:balancer)

PY2_LIBRARY()

PY_SRCS(
    __init__.py

    asserts/__init__.py

    awacs/__init__.py
    awacs/_awacs.py
    awacs/special_values.py

    backend/__init__.py
    backend/_backend.py
    backend/syn_blackhole.py
    backend/socket_server.py

    balancer/__init__.py
    balancer/_balancer.py
    balancer/asserts.py

    cachedaemon/__init__.py
    cachedaemon/_cachedaemon.py

    certs/__init__.py
    certs/_certs.py

    checkers/__init__.py

    config/__init__.py
    config/_config.py

    connection/__init__.py

    context/__init__.py
    context/_context.py

    dnsfake/__init__.py
    dnsfake/bimap.py
    dnsfake/bit.py
    dnsfake/buffer.py
    dnsfake/dns.py
    dnsfake/fixedresolver.py
    dnsfake/label.py
    dnsfake/lex.py
    dnsfake/ranges.py
    dnsfake/server.py
    dnsfake/zoneresolver.py

    dolbilo/__init__.py

    fs/__init__.py

    func/__init__.py
    func/_func.py
    func/asserts.py
    func/html.py
    func/plot.py

    multiscope/__init__.py

    options/__init__.py

    port/__init__.py

    predef/__init__.py
    predef/http/__init__.py
    predef/http/request.py
    predef/http/response.py
    predef/http2/__init__.py
    predef/http2/request.py

    predef/handler/__init__.py
    predef/handler/server/__init__.py
    predef/handler/server/http.py

    process/__init__.py

    proto/__init__.py
    proto/handler/__init__.py
    proto/handler/client/__init__.py
    proto/handler/client/http.py
    proto/handler/server/__init__.py
    proto/handler/server/_common.py
    proto/handler/server/http.py

    proto/iface/__init__.py
    proto/iface/data.py
    proto/iface/headers.py
    proto/iface/message.py
    proto/http/__init__.py
    proto/http/message.py
    proto/http/stream.py
    proto/http2/__init__.py
    proto/http2/connection.py
    proto/http2/errors.py
    proto/http2/message.py
    proto/http2/stream.py
    proto/http2/framing/__init__.py
    proto/http2/framing/flags.py
    proto/http2/framing/frames.py
    proto/http2/framing/stream.py
    proto/ws/stream.py

    resource/__init__.py

    server/__init__.py

    settings/__init__.py
    settings/_default_flags.py
    settings/_flags.py
    settings/_settings.py

    sd/__init__.py

    stdlib/__init__.py
    stdlib/c_zlib.py
    stdlib/doc_inherit.py
    stdlib/memoize.py
    stdlib/multirun.py
    stdlib/named.py
    stdlib/singleton.py

    stream/__init__.py
    stream/_stream.py
    stream/io/__init__.py
    stream/io/bit.py
    stream/io/byte.py
    stream/io/stream.py
    stream/ssl/__init__.py
    stream/ssl/parse.py
    stream/ssl/stream.py

    sync/__init__.py

    tcpdump/__init__.py

    sanitizers/__init__.py
)

RESOURCE_FILES(
    func/highcharts.js
    func/highcharts-more.js
    func/exporting.js
)

PEERDIR(
    balancer/production/x/lua_to_json
    balancer/test/util/proto/http2/hpack
    balancer/test/util/rpslimiter
    balancer/test/util/sanitizers
    balancer/test/util/stdlib
    balancer/test/util/sync
    contrib/python/Jinja2
    contrib/python/dpkt  # used in util/tcpdump.py
    contrib/deprecated/python/ipaddress
    contrib/python/netifaces
    contrib/python/pyOpenSSL
    contrib/python/pytest  # FIXME: used in multiscope
    contrib/python/requests
    infra/yp_service_discovery/api
    library/python/pytest/allure
)

DEFAULT(USE_NGINX no)
CONFIGURE_FILE(settings/_flags.py.in settings/_flags.py)

END()
